package io.tswf.minecraft.blockventure.core.api.world.chunk

import groovy.transform.CompileStatic
import groovy.transform.EqualsAndHashCode
import groovy.transform.ToString
import io.tswf.groovy.bettergroovy.transforms.validation.checkedmapconstructor.CheckedMapConstructor
import io.tswf.minecraft.blockventure.core.world.chunk.ChunkPersistTrackerService
import net.minecraft.registry.RegistryKey
import net.minecraft.world.dimension.DimensionType

@CompileStatic
class ChunkPersistManager {

    static UUID persistChunks(RegistryKey<DimensionType> dimensionKey, List<PersistedChunkCoord> chunkPositions) {
        return ChunkPersistTrackerService.persistChunks(dimensionKey.value, chunkPositions)
    }

    static void freeChunks(UUID trackerId) {
        ChunkPersistTrackerService.freeChunks(trackerId)
    }
}

@ToString(includePackage = false, includeNames = true)
@EqualsAndHashCode
@CheckedMapConstructor
@CompileStatic
class PersistedChunkCoord {
    int x
    int z
}
